package javadocExamplesFor240.Test;

import static org.junit.Assert.*;
import javadocExamples.Date;

import org.junit.Test;

public class DateTest2 {
	@Test
	public void testDate() {
		Date date = new Date(1,2,3);
		assertTrue(date.getDay() == 3 && date.getMonth() == 2 && date.getYear() == 1);
		
		date = new Date(1,2,28);
		assertTrue(date.getDay() == 28 && date.getMonth() == 2 && date.getYear() == 1);
		
		date = new Date(1,2,15);
		assertTrue(date.getDay() == 15 && date.getMonth() == 2 && date.getYear() == 1);
		
		date = new Date(2004,2,29);
		assertTrue(date.getDay() == 29 && date.getMonth() == 2 && date.getYear() == 2004);
		
		date = new Date(2000, 2, 28);
		assertTrue(date.getDay() == 28 && date.getMonth() == 2 && date.getYear() == 2000);
		
		date = new Date(1200, 2, 29);
		assertTrue(date.getDay() == 29 && date.getMonth() == 2 && date.getYear() == 1200);
		
		try{
			date = new Date(-1, 2, 3);
			fail("Year cannot be negative");
		}catch(AssertionError e) {}	
		
		try{
			date = new Date(0, 2, 3);
			fail("Year cannot be negative");
		}catch(AssertionError e) {}
		
		try{
			date = new Date(10000, 2, 3);
			fail("Year must be less than 10000");
		}catch(AssertionError e) {}
		
		try{
			date = new Date(1, 0, 3);
			fail("Year cannot be <= 0");
		}catch(AssertionError e) {}
		
		try{
			date = new Date(1, 13, 3);
			fail("Year cannot be > 12");
		}catch(AssertionError e) {}	
		
		try{
			date = new Date(1, 2, 0);
			fail("Day must be > 0");
		}catch(AssertionError e) {}
		
		try{
			date = new Date(1, 2, -1);
			fail("Day must be > 0");
		}catch(AssertionError e) {}	
		
		try{
			date = new Date(1, 2, 0);
			fail("Day must be > 0");
		}catch(AssertionError e) {}	
		
		try{
			date = new Date(1, 2, 32);
			fail("Day must be < 32");
		}catch(AssertionError e) {}
		
		try{
			date = new Date(1, 2, 29);
			fail("Day must be < 29 if it is not a leap year");
		}catch(AssertionError e) {}
		
		try{
			date = new Date(2004, 2, 30);
			fail("If it is a leap year then the day must be <= 29");
		}catch(AssertionError e) {}
		
		try{
			date = new Date(2000, 2, 29);
			fail("If the year is a not a leap year then the day must be <= 28");
		}catch(AssertionError e) {}
	}

	@Test
	public void testGetDay() {
		Date date = new Date(2015, 10, 13);
		assert(date.getDay() == 13);
	}

	@Test
	public void testGetMonth() {
		Date date = new Date(2015, 10, 13);
		assert(date.getMonth() == 10);
	}

	@Test
	public void testGetYear() {
		Date date = new Date(2015, 10, 13);
		assert(date.getYear() == 2015);
	}

	@Test
	public void testToString() {
		Date date = new Date(2004, 10, 15);
		assertTrue(date.toString().equals("15/10/2004"));
		
		date = new Date(2004, 10, 1);
		assertTrue(date.toString().equals("01/10/2004"));
		
		date = new Date(2004, 10, 9);
		assertTrue(date.toString().equals("09/10/2004"));
		
		date = new Date(2004, 1, 11);
		assertTrue(date.toString().equals("11/01/2004"));
		
		date = new Date(2004, 9, 30);
		assertTrue(date.toString().equals("30/09/2004"));
		
		date = new Date(2004, 12, 31);
		assertTrue(date.toString().equals("31/12/2004"));
		
		date = new Date(1, 12, 31);
		assertTrue(date.toString().equals("31/12/0001"));
		
		date = new Date(12, 12, 31);
		assertTrue(date.toString().equals("31/12/0012"));
		
		date = new Date(123, 12, 31);
		assertTrue(date.toString().equals("31/12/0123"));
		
		date = new Date(1234, 12, 31);
		assertTrue(date.toString().equals("31/12/1234"));
	}

	@Test
	public void testSetDay() {
		Date date = new Date(2015, 10, 13);
		date.setDay(14);
		assertTrue(date.getDay() == 14);
		
		date.setDay(28);
		assertTrue(date.getDay() == 28);
		
		date.setDay(29);
		assertTrue(date.getDay() == 29);
		
		date.setDay(30);
		assertTrue(date.getDay() == 30);
		
		date.setDay(31);
		assertTrue(date.getDay() == 31);
		
		date = new Date(2015, 11, 20);
		date.setDay(30);
		assertTrue(date.getDay() == 30);
		
		date = new Date(2004, 2, 15);
		date.setDay(29);
		assertTrue(date.getDay() == 29);
		
		date = new Date(2000, 2, 15);
		date.setDay(28);
		assertTrue(date.getDay() == 28);
		
		date = new Date(2400, 2, 15);
		date.setDay(29);
		assertTrue(date.getDay() == 29);
		
		try{
			date.setDay(0);
			fail();
		}catch(AssertionError e){}
		
		try{
			date.setDay(32);
			fail();
		}catch(AssertionError e){}
		
		try{
			date = new Date(2015, 1, 21);
			date.setDay(32);
			fail();
		}catch(AssertionError e){}
		
		try{
			date = new Date(2015, 3, 21);
			date.setDay(32);
			fail();
		}catch(AssertionError e){}
		
		try{
			date = new Date(2015, 5, 21);
			date.setDay(32);
			fail();
		}catch(AssertionError e){}
		
		try{
			date = new Date(2015, 7, 21);
			date.setDay(32);
			fail();
		}catch(AssertionError e){}
		
		try{
			date = new Date(2015, 8, 21);
			date.setDay(32);
			fail();
		}catch(AssertionError e){}
		
		try{
			date = new Date(2015, 10, 21);
			date.setDay(32);
			fail();
		}catch(AssertionError e){}
		
		try{
			date = new Date(2015, 12, 21);
			date.setDay(32);
			fail();
		}catch(AssertionError e){}
		
		try{
			date = new Date(2015, 4, 21);
			date.setDay(31);
			fail();
		}catch(AssertionError e){}
		
		try{
			date = new Date(2015, 6, 21);
			date.setDay(32);
			fail();
		}catch(AssertionError e){}
		
		try{
			date = new Date(2015, 9, 21);
			date.setDay(32);
			fail();
		}catch(AssertionError e){}
		
		try{
			date = new Date(2015, 11, 21);
			date.setDay(32);
			fail();
		}catch(AssertionError e){}
		
		try{
			date = new Date(2004, 2, 15);
			date.setDay(30);
			fail();
		}catch(AssertionError e){}
		
		try{
			date = new Date(2000, 2, 21);
			date.setDay(29);
			fail();
		}catch(AssertionError e){}
		
}

	@Test
	public void testSetMonth() {
		Date date = new Date(2015, 10, 13);
		date.setMonth(5);
		assertTrue(date.getMonth() == 5);
		
		date.setMonth(1);
		assertTrue(date.getMonth() == 1);
		
		date.setMonth(12);
		assertTrue(date.getMonth() == 12);
		
		date = new Date(2015, 11, 28);
		date.setMonth(2);
		assertTrue(date.getMonth() == 2);
		
		date = new Date(2004, 1, 29);
		date.setMonth(2);
		assertTrue(date.getMonth() == 2);
		
		date = new Date(2000, 3, 28);
		date.setMonth(2);
		assertTrue(date.getMonth() == 2);
		
		date = new Date(1600, 3, 29);
		date.setMonth(2);
		assertTrue(date.getMonth() == 2);
		
		try{
			date.setMonth(0);
			fail();
		}catch(AssertionError e){}
		
		try{
			date.setMonth(13);
			fail();
		}catch(AssertionError e){}
		
		date = new Date(2015, 1, 31);
		try{
			date.setMonth(4);
			fail();
		}catch(AssertionError e){}
		
		try{
			date.setMonth(6);
			fail();
		}catch(AssertionError e){}
		
		try{
			date.setMonth(11);
			fail();
		}catch(AssertionError e){}
		
		try{
			date.setMonth(9);
			fail();
		}catch(AssertionError e){}
		
		try{
			date = new Date(2015, 1, 31);
			date.setMonth(2);
			fail();
		}catch(AssertionError e){}
		
		try{
			date = new Date(2015, 11, 30);
			date.setMonth(2);
			fail();
		}catch(AssertionError e){}
		
		try{
			date = new Date(2004, 12, 30);
			date.setMonth(2);
			fail();
		}catch(AssertionError e){}
		
		try{
			date = new Date(2004, 11, 30);
			date.setMonth(2);
			fail();
		}catch(AssertionError e){}
		
		try{
			date = new Date(2005, 11, 29);
			date.setMonth(2);
			fail();
		}catch(AssertionError e){}
		
		try{
			date = new Date(2004, 6, 30);
			date.setMonth(2);
			fail();
		}catch(AssertionError e){}
	}

	@Test
	public void testSetYear() {
		Date date = new Date(2015, 10, 13);
		date.setYear(0);
		assertTrue(date.getYear() == 0);
		
		date.setYear(1);
		assertTrue(date.getYear() == 1);
		
		date.setYear(100);
		assertTrue(date.getYear() == 100);
		
		date = new Date(2004, 2, 29);
		date.setYear(1996);
		assertTrue(date.getYear() == 1996);
		
		date = new Date(2004, 2, 29);
		date.setYear(2016);
		assertTrue(date.getYear() == 2016);
		
		date = new Date(2004, 2, 29);
		date.setYear(4);
		assertTrue(date.getYear() == 4);
		
		date = new Date(2004, 2, 29);
		date.setYear(4);
		assertTrue(date.getYear() == 4);
		
		date = new Date(1999, 2, 28);
		date.setYear(2000);
		assertTrue(date.getYear() == 2000);
		
		date = new Date(1996, 2, 29);
		date.setYear(2400);
		assertTrue(date.getYear() == 2400);
		
		date = new Date(1992, 2, 29);
		try{
			date.setYear(-1);
			fail();
		}catch(AssertionError e){}
		
		try {
			date.setYear(10000);
			assertTrue(date.getYear() == 10000);
		} catch(AssertionError e) {}
		
		date = new Date(1992, 2, 29);
		try{
			date.setYear(0);
			fail();
		}catch(AssertionError e){}
		
		date = new Date(1992, 2, 29);
		try{
			date.setYear(1993);
			fail();
		}catch(AssertionError e){}
		
		try{
			date.setYear(2000);
			fail();
		}catch(AssertionError e){}
	}

}
